using System;
using System.Collections.Generic;
using System.Text;
using AviFile;
using System.Drawing;
using RNumericImage;
using CRFractal;
using FractalAnimator;


namespace Rakabrot
{
    class RAnimationConverter
    {
        AviManager aviManager; 
        VideoStream aviStream;

        public RAnimationConverter(string InputAnimationFile)
        {
            SetAnimationFile(InputAnimationFile);
        }
         ~RAnimationConverter()
        {
//            SetAnimationFile(InputAnimationFile);
            aviManager.Close();
        }

        public void SetAnimationFile(string InputAnimationFile)
        {
            aviManager = new AviManager(InputAnimationFile, true);
            aviStream = aviManager.GetVideoStream();
            aviStream.GetFrameOpen();
        }

        public void Convert(string fileName)
        {


            string tempFileName;

//            VideoStream NewAviStream =new VideoStream aviManager.AddVideoStream(true, 16, aviStream.GetBitmap(0));
            
//             aviStream.GetBitmap(i)
             Bitmap picFrame = aviStream.GetBitmap(0);

             RColorHolder iColorHolder = new RColorHolder();
             RNumericImageTexture Mtexture = 
                 new RNumericImageTexture(picFrame.Width, picFrame.Height) ;
             AviWriter mAviWriter;
             mAviWriter = new AviWriter();

             Bitmap bmp = mAviWriter.Open(fileName+".avi", 25, picFrame.Width, picFrame.Height);
             Graphics g = Graphics.FromImage(bmp);

            for (int i = 0; i < aviStream.CountFrames; i++)
            {

                picFrame = new Bitmap(aviStream.GetBitmap(i));
                //                picFrame.Image =
                //            ;
                tempFileName = fileName + i;
                tempFileName += ".bmp";
             /*   Mtexture.ConvertBmpToData(picFrame, iColorHolder);
                */
//                mFractal.Mandelbrot.DrawImage(g);
//                Mtexture.SaveBitMap(tempFileName);
                Mtexture.DrawImage(g);
                mAviWriter.AddFrame();
//                NewAviStream.AddFrame(picFrame);
             //   picFrame.Save(tempFileName);
                picFrame.Dispose();

            }
//             NewAviStream.
//            aviStream.ExportStream(fileName + ".avi");
//            aviStream.ExportStream("d:\\proba.avi");
//            aviStream.Close();
            //NewAviStream.ExportStream(fileName + ".avi");
            mAviWriter.Close();
        }
    }
}
