using System;

using RakabrotPluginInterface.RMath;


namespace RakabrotPluginInterface
{

    namespace RCommon
    {
        /// <summary>
        /// 
        /// </summary>
        public class RPathArray
        {
            double[] mReal;
            double[] mImag;
            int mCurrent;
            int MaxIndex;

            public RPathArray()
            {
                // 
                // TODO: Add constructor logic here
                //
                MaxIndex = 0;
                mCurrent = 0;
            }
            public RPathArray(int Size)
            {
                // 
                // TODO: Add constructor logic here
                //
                mReal = new double[Size];
                mImag = new double[Size];
                MaxIndex = 0;
            }
            public void AddElement(Complex newValue)
            {
                mReal[MaxIndex] = newValue.Real;
                mImag[MaxIndex] = newValue.Imag;

                MaxIndex++;

            }
            public void Clear()
            {
                MaxIndex = 0;
            }
            public Complex this[int i]
            {
                get
                {
                    return new Complex(mReal[i], mImag[i]);
                }
                set
                {
                    mReal[i] = value.Real;
                    mImag[i] = value.Imag;
                }
            }
            public int GetMaxIndex() { return MaxIndex; }
            public void ResetCurrent()
            {
                mCurrent = 0;
            }
            public bool GetCurrent(out double real, out  double imag)
            {
                real = mReal[mCurrent];
                imag = mImag[mCurrent];
                mCurrent++;
                if (mCurrent >= MaxIndex)
                    return false;
                else
                    return true;

            }
        }
    }
}