using System;
using System.IO;


namespace RakabrotPluginInterface
{
    namespace RCommon
    {
        /// <summary>
        /// 
        /// </summary>
        public class RVector
        {

            double mX;
            double mY;
            public RVector()
            {
                // 
                // TODO: Add constructor logic here
                //
                mX = 0;
                mY = 0;
            }
            public RVector(double nX, double nY)
            {
                // 
                // TODO: Add constructor logic here
                //
                mX = nX;
                mY = nY;
            }

            public double X
            {
                get
                {
                    return mX;
                }
                set
                {
                    mX = value;
                }
            }

            public double Y
            {
                get
                {
                    return mY;
                }
                set
                {
                    mY = value;
                }
            }

            public void Mult(double mult)
            {
                mX = mult * mX;
                mY = mult * mY;
            }

            public void LoadFromFile(StreamReader sr)
            {
                String Line;

                Line = sr.ReadLine();
                Line = sr.ReadLine();
                mX = System.Convert.ToDouble(Line);

                Line = sr.ReadLine();
                Line = sr.ReadLine();
                mY = System.Convert.ToDouble(Line);
            }

            public void SaveToFile(StreamWriter sw, string ExtraInfo)
            {
                sw.WriteLine(ExtraInfo + " X:");
                sw.WriteLine(mX);
                sw.WriteLine(ExtraInfo + "Y:");
                sw.WriteLine(mY);

            }

            public static RVector operator +(RVector A, RVector B)
            {
                return new RVector(B.mX + A.mX, B.mY + A.mY);

            }
            public static RVector operator -(RVector A, RVector B)
            {
                return new RVector(A.mX - B.mX, A.mY - B.mY);

            }
            public static RVector operator *(RVector A, double B)
            {
                return new RVector(A.mX * B, A.mY * B);

            }
            public static RVector operator /(RVector A, double B)
            {
                return new RVector(A.mX / B, A.mY / B);

            }

            public void Set(RVector A)
            {
                X = A.X;
                Y = A.Y;
            }
        }
    }
}