using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace RNumericImage
{
    public class RColorHolder
    {
        Color[] ColorPalete = new Color[50000];

        int MaxIndex = 0;
        int Precision;   
        public RColorHolder()
        {
            MaxIndex    = 0;
            Precision   = 6;

        }

        public uint GetColorIndex(Color TestColor)
        {

            for (uint i = 0; i < MaxIndex; i++)
                if ((ColorPalete[i].R >> Precision) == (TestColor.R >> Precision) &&
                    (ColorPalete[i].G >> Precision) == (TestColor.G >> Precision) &&
                    (ColorPalete[i].B >> Precision) == (TestColor.B >> Precision))
                    return i;

            ColorPalete[MaxIndex] = TestColor;
            MaxIndex++;

            return (uint)(MaxIndex - 1);

        }
    }
}
