using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.IO;


namespace RImageTexture
{
    class RTexture
    {

        Bitmap      mBitmap;
        string      mFileName;


        public RTexture(string TextureFileName)
        {
            mFileName = TextureFileName;
            LoadBitmap(TextureFileName);
        }


        public void Load(StreamReader sr)
        {
            mFileName = sr.ReadLine();
            mBitmap = new Bitmap(mFileName);


        }

        public void LoadBitmap(string TextureFileName)
        {

            mBitmap = new Bitmap(TextureFileName);


        }
        
        public Color GetPixel(int i, int j) 
        {
            if ((mBitmap.Width > i) && (i >= 0) &&
               (mBitmap.Height > j) && (j >= 0))
                return mBitmap.GetPixel(i, j);
            else
                return System.Drawing.Color.Black;

        }

        public void Save(StreamWriter sw){
            sw.WriteLine(mFileName);
        }
    }
}
