using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace RNGradient
{
	/// <summary>
	/// Summary description for FormGradient.
	/// </summary>
	public class FormGradient : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panelAll;
		private System.Windows.Forms.Panel panelGradientImage;
		private System.Windows.Forms.PictureBox pictureBoxGradient;
		private System.Windows.Forms.Panel panelGradientColor;
		private System.Windows.Forms.Panel panelGradientColorTop;
		private System.Windows.Forms.Panel panelGradientColorBottom;
		private System.Windows.Forms.Panel panelGradientColorFill;
        private RNGradient.RContorlGradientColor rContorlGradientColor1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.MenuItem menuSave;
        private System.Windows.Forms.MenuItem menuLoad;
        private IContainer components;
        private Label label1;
        private ComboBox CBActiveGradient;
        private Panel panelGradientpositionContorl;
        private RContorlGradientColor rContorlGradientColor2;
        private Panel panelGradientActiveButtons;
        private Button DeleteGradient;
        private Button AddGradientPoistion;
        private RGradient mGradient;


		public FormGradient()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			mGradient		  = new RGradient(50);	

		}

        public RGradient Gradient
        {
            get
            {
                return mGradient;
            }
            set
            {
                mGradient = value;
            }
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            RNGradient.RGradientPosition rGradientPosition1 = new RNGradient.RGradientPosition();
            RNGradient.RGradientPosition rGradientPosition2 = new RNGradient.RGradientPosition();
            this.panelAll = new System.Windows.Forms.Panel();
            this.panelGradientImage = new System.Windows.Forms.Panel();
            this.panelGradientColor = new System.Windows.Forms.Panel();
            this.panelGradientpositionContorl = new System.Windows.Forms.Panel();
            this.rContorlGradientColor2 = new RNGradient.RContorlGradientColor();
            this.panelGradientActiveButtons = new System.Windows.Forms.Panel();
            this.DeleteGradient = new System.Windows.Forms.Button();
            this.AddGradientPoistion = new System.Windows.Forms.Button();
            this.panelGradientColorTop = new System.Windows.Forms.Panel();
            this.label1 = new System.Windows.Forms.Label();
            this.CBActiveGradient = new System.Windows.Forms.ComboBox();
            this.panelGradientColorFill = new System.Windows.Forms.Panel();
            this.panelGradientColorBottom = new System.Windows.Forms.Panel();
            this.mainMenu1 = new System.Windows.Forms.MainMenu(this.components);
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.menuSave = new System.Windows.Forms.MenuItem();
            this.menuLoad = new System.Windows.Forms.MenuItem();
            this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
            this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
            this.rContorlGradientColor1 = new RNGradient.RContorlGradientColor();
            this.pictureBoxGradient = new System.Windows.Forms.PictureBox();
            this.panelAll.SuspendLayout();
            this.panelGradientImage.SuspendLayout();
            this.panelGradientColor.SuspendLayout();
            this.panelGradientpositionContorl.SuspendLayout();
            this.panelGradientActiveButtons.SuspendLayout();
            this.panelGradientColorTop.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBoxGradient)).BeginInit();
            this.SuspendLayout();
            // 
            // panelAll
            // 
            this.panelAll.Controls.Add(this.panelGradientImage);
            this.panelAll.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panelAll.Location = new System.Drawing.Point(0, 0);
            this.panelAll.Name = "panelAll";
            this.panelAll.Size = new System.Drawing.Size(419, 376);
            this.panelAll.TabIndex = 3;
            // 
            // panelGradientImage
            // 
            this.panelGradientImage.Controls.Add(this.pictureBoxGradient);
            this.panelGradientImage.Location = new System.Drawing.Point(-60, 104);
            this.panelGradientImage.Name = "panelGradientImage";
            this.panelGradientImage.Size = new System.Drawing.Size(520, 128);
            this.panelGradientImage.TabIndex = 2;
            // 
            // panelGradientColor
            // 
            this.panelGradientColor.Controls.Add(this.panelGradientpositionContorl);
            this.panelGradientColor.Controls.Add(this.panelGradientActiveButtons);
            this.panelGradientColor.Controls.Add(this.panelGradientColorTop);
            this.panelGradientColor.Dock = System.Windows.Forms.DockStyle.Right;
            this.panelGradientColor.Location = new System.Drawing.Point(419, 0);
            this.panelGradientColor.Name = "panelGradientColor";
            this.panelGradientColor.Size = new System.Drawing.Size(208, 376);
            this.panelGradientColor.TabIndex = 2;
            // 
            // panelGradientpositionContorl
            // 
            this.panelGradientpositionContorl.Controls.Add(this.rContorlGradientColor2);
            this.panelGradientpositionContorl.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panelGradientpositionContorl.Location = new System.Drawing.Point(0, 77);
            this.panelGradientpositionContorl.Name = "panelGradientpositionContorl";
            this.panelGradientpositionContorl.Size = new System.Drawing.Size(208, 220);
            this.panelGradientpositionContorl.TabIndex = 3;
            // 
            // rContorlGradientColor2
            // 
            this.rContorlGradientColor2.Dock = System.Windows.Forms.DockStyle.Fill;
            rGradientPosition1.B = ((byte)(0));
            rGradientPosition1.G = ((byte)(0));
            rGradientPosition1.Position = ((uint)(0u));
            rGradientPosition1.R = ((byte)(0));
            this.rContorlGradientColor2.GradientPosition = rGradientPosition1;
            this.rContorlGradientColor2.Location = new System.Drawing.Point(0, 0);
            this.rContorlGradientColor2.Name = "rContorlGradientColor2";
            this.rContorlGradientColor2.Size = new System.Drawing.Size(208, 220);
            this.rContorlGradientColor2.TabIndex = 2;
            this.rContorlGradientColor2.Leave += new System.EventHandler(this.rContorlGradientColor2_Leave);
            // 
            // panelGradientActiveButtons
            // 
            this.panelGradientActiveButtons.Controls.Add(this.DeleteGradient);
            this.panelGradientActiveButtons.Controls.Add(this.AddGradientPoistion);
            this.panelGradientActiveButtons.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panelGradientActiveButtons.Location = new System.Drawing.Point(0, 297);
            this.panelGradientActiveButtons.Name = "panelGradientActiveButtons";
            this.panelGradientActiveButtons.Size = new System.Drawing.Size(208, 79);
            this.panelGradientActiveButtons.TabIndex = 2;
            // 
            // DeleteGradient
            // 
            this.DeleteGradient.Location = new System.Drawing.Point(35, 43);
            this.DeleteGradient.Name = "DeleteGradient";
            this.DeleteGradient.Size = new System.Drawing.Size(130, 31);
            this.DeleteGradient.TabIndex = 1;
            this.DeleteGradient.Text = "Delete Gradient Point";
            this.DeleteGradient.UseVisualStyleBackColor = true;
            this.DeleteGradient.Click += new System.EventHandler(this.DeleteGradient_Click);
            // 
            // AddGradientPoistion
            // 
            this.AddGradientPoistion.Location = new System.Drawing.Point(35, 6);
            this.AddGradientPoistion.Name = "AddGradientPoistion";
            this.AddGradientPoistion.Size = new System.Drawing.Size(130, 31);
            this.AddGradientPoistion.TabIndex = 0;
            this.AddGradientPoistion.Text = "Add Gradient Point";
            this.AddGradientPoistion.UseVisualStyleBackColor = true;
            this.AddGradientPoistion.Click += new System.EventHandler(this.AddGradientPoistion_Click);
            // 
            // panelGradientColorTop
            // 
            this.panelGradientColorTop.Controls.Add(this.label1);
            this.panelGradientColorTop.Controls.Add(this.CBActiveGradient);
            this.panelGradientColorTop.Dock = System.Windows.Forms.DockStyle.Top;
            this.panelGradientColorTop.Location = new System.Drawing.Point(0, 0);
            this.panelGradientColorTop.Name = "panelGradientColorTop";
            this.panelGradientColorTop.Size = new System.Drawing.Size(208, 77);
            this.panelGradientColorTop.TabIndex = 0;
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(10, 9);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(102, 17);
            this.label1.TabIndex = 1;
            this.label1.Text = "Active gradient";
            // 
            // CBActiveGradient
            // 
            this.CBActiveGradient.FormattingEnabled = true;
            this.CBActiveGradient.Location = new System.Drawing.Point(13, 29);
            this.CBActiveGradient.Name = "CBActiveGradient";
            this.CBActiveGradient.Size = new System.Drawing.Size(183, 21);
            this.CBActiveGradient.TabIndex = 0;
            this.CBActiveGradient.SelectedIndexChanged += new System.EventHandler(this.CBActiveGradient_SelectedIndexChanged);
            // 
            // panelGradientColorFill
            // 
            this.panelGradientColorFill.Location = new System.Drawing.Point(0, 0);
            this.panelGradientColorFill.Name = "panelGradientColorFill";
            this.panelGradientColorFill.Size = new System.Drawing.Size(200, 100);
            this.panelGradientColorFill.TabIndex = 0;
            // 
            // panelGradientColorBottom
            // 
            this.panelGradientColorBottom.Location = new System.Drawing.Point(0, 0);
            this.panelGradientColorBottom.Name = "panelGradientColorBottom";
            this.panelGradientColorBottom.Size = new System.Drawing.Size(200, 100);
            this.panelGradientColorBottom.TabIndex = 0;
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem1});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuSave,
            this.menuLoad});
            this.menuItem1.Text = "File";
            // 
            // menuSave
            // 
            this.menuSave.Index = 0;
            this.menuSave.Text = "Save";
            this.menuSave.Click += new System.EventHandler(this.menuSave_Click);
            // 
            // menuLoad
            // 
            this.menuLoad.Index = 1;
            this.menuLoad.Text = "Load";
            this.menuLoad.Click += new System.EventHandler(this.menuLoad_Click);
            // 
            // rContorlGradientColor1
            // 
            rGradientPosition2.B = ((byte)(0));
            rGradientPosition2.G = ((byte)(0));
            rGradientPosition2.Position = ((uint)(0u));
            rGradientPosition2.R = ((byte)(0));
            this.rContorlGradientColor1.GradientPosition = rGradientPosition2;
            this.rContorlGradientColor1.Location = new System.Drawing.Point(0, 0);
            this.rContorlGradientColor1.Name = "rContorlGradientColor1";
            this.rContorlGradientColor1.Size = new System.Drawing.Size(200, 288);
            this.rContorlGradientColor1.TabIndex = 0;
            // 
            // pictureBoxGradient
            // 
            this.pictureBoxGradient.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.pictureBoxGradient.Location = new System.Drawing.Point(0, 32);
            this.pictureBoxGradient.Name = "pictureBoxGradient";
            this.pictureBoxGradient.Size = new System.Drawing.Size(520, 96);
            this.pictureBoxGradient.TabIndex = 0;
            this.pictureBoxGradient.TabStop = false;
            // 
            // FormGradient
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(627, 376);
            this.Controls.Add(this.panelAll);
            this.Controls.Add(this.panelGradientColor);
            this.Menu = this.mainMenu1;
            this.Name = "FormGradient";
            this.Text = "Gradient";
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.FormGradient_Paint);
            this.Activated += new System.EventHandler(this.FormGradient_Activated);
            this.panelAll.ResumeLayout(false);
            this.panelGradientImage.ResumeLayout(false);
            this.panelGradientColor.ResumeLayout(false);
            this.panelGradientpositionContorl.ResumeLayout(false);
            this.panelGradientActiveButtons.ResumeLayout(false);
            this.panelGradientColorTop.ResumeLayout(false);
            this.panelGradientColorTop.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBoxGradient)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		private void FormGradient_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			rContorlGradientColor1.Refresh();
		
		}


		private void menuSave_Click(object sender, System.EventArgs e)
		{
			if (saveFileDialog1.ShowDialog() == DialogResult.OK)
			{
				if(mGradient!= null )
					mGradient.SaveToFile(saveFileDialog1.FileName);

			}
		}

		private void menuLoad_Click(object sender, System.EventArgs e)
		{
			if (openFileDialog1.ShowDialog() == DialogResult.OK)
			{
				if(mGradient!= null )
					mGradient.LoadFromFile(openFileDialog1.FileName);

			}
		
		}

        private void CBActiveGradient_SelectedIndexChanged(object sender, EventArgs e)
        {

            mGradient.SetActiveFromPosition(Convert.ToInt32(CBActiveGradient.Text));
            rContorlGradientColor2.GradientPosition = mGradient.GetActive();
        }
        public void FillActiveComboGradient() 
        { 
        CBActiveGradient.Items.Clear();
        mGradient.Sort();
            for (uint i = 0; i < mGradient.GetMaxIndex(); i++)
            {
                CBActiveGradient.Items.Add(Convert.ToString(mGradient[i].Position));
            }
            if (mGradient.GetActive() != null)
            CBActiveGradient.Text = Convert.ToString(
                        mGradient.GetActive().Position);
        }

        private void rContorlGradientColor2_Load(object sender, EventArgs e)
        {
        }
            

        private void AddGradientPoistion_Click(object sender, EventArgs e)
        {
            mGradient.NewGradientPosition();
            FillActiveComboGradient();
        }

        private void DeleteGradient_Click(object sender, EventArgs e)
        {
            mGradient.DeleteActive();
            FillActiveComboGradient();
        }

        private void rContorlGradientColor2_Leave(object sender, EventArgs e)
        {
            FillActiveComboGradient();
        }

        private void FormGradient_Activated(object sender, EventArgs e)
        {
            FillActiveComboGradient(); 

        }

	}
}
