using System;
using System.Collections.Generic;
using System.Text;
using RakabrotPluginInterface;

namespace RakabrotZPowerPlugin
{
    public class PluginInfo: RakabrotPluginInterface.IPluginInfo
    {
        public string Name
        {
            get { return "ZPowerPlugin"; }
        }

        public RakabrotPluginInterface.RFractalFormulaAbstract GetFormula()
        {
            return new RFractalFormulaZPower();
        }
        public RakabrotPluginInterface.RFractalFormulaAbstract GetFormula(string StartDirectory)
        {
            return new RFractalFormulaZPower(StartDirectory);
        }
    }
}
