using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Inferno.Utilities;

namespace Rakabrot
{
    public delegate void UpdatePaletteEventHandler(bool a);

    public partial class RControlColorGradient : Form
    {
//        private Inferno.Utilities.GradientTypeEditorUI gradientTypeEditorUI1;

        public event UpdatePaletteEventHandler UpdatePalette;


        public RControlColorGradient()
        {
            InitializeComponent();
            

        }
        
        public MarkerList GetMarkers() { return gradientTypeEditorUI1.GetMarkers(); }
        public void SetMarkers(MarkerList nMarkers) { gradientTypeEditorUI1.SetMarkers(nMarkers); this.propertyGrid1.SelectedObject = gradientTypeEditorUI1.GetMarkers(); }
        /*
        private void InitializeComponent()
        {
            Inferno.Utilities.Gradient gradient1 = new Inferno.Utilities.Gradient();
            System.Drawing.Drawing2D.ColorBlend colorBlend1 = new System.Drawing.Drawing2D.ColorBlend();
            this.gradientTypeEditorUI1 = new Inferno.Utilities.GradientTypeEditorUI();
            this.buttonOK = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // gradientTypeEditorUI1
            // 
            colorBlend1.Colors = new System.Drawing.Color[] {
        System.Drawing.Color.White,
        System.Drawing.Color.White};
            colorBlend1.Positions = new float[] {
        0F,
        1F};
            gradient1.ColorBlend = colorBlend1;
            gradient1.GradientDirection = System.Drawing.Drawing2D.LinearGradientMode.Horizontal;
            this.gradientTypeEditorUI1.Gradient = gradient1;
            this.gradientTypeEditorUI1.Location = new System.Drawing.Point(12, 30);
            this.gradientTypeEditorUI1.Name = "gradientTypeEditorUI1";
            this.gradientTypeEditorUI1.Size = new System.Drawing.Size(462, 118);
            this.gradientTypeEditorUI1.TabIndex = 0;
            // 
            // buttonOK
            // 
            this.buttonOK.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.buttonOK.Location = new System.Drawing.Point(346, 192);
            this.buttonOK.Name = "buttonOK";
            this.buttonOK.Size = new System.Drawing.Size(127, 32);
            this.buttonOK.TabIndex = 1;
            this.buttonOK.Text = "OK";
            this.buttonOK.UseVisualStyleBackColor = true;
            this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
            // 
            // RControlColorGradient
            // 
            this.ClientSize = new System.Drawing.Size(486, 237);
            this.Controls.Add(this.buttonOK);
            this.Controls.Add(this.gradientTypeEditorUI1);
            this.Name = "RControlColorGradient";
            this.ResumeLayout(false);

        }
*/
        private void buttonOK_Click(object sender, EventArgs e)
        {
            
            if (UpdatePalette != null) 
            {
                UpdatePalette(true);
            }
            this.Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (UpdatePalette != null)
            {
                UpdatePalette(true);
            }
        }
    }
}