using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.IO;
namespace RImageTexture
{
    class RTextureHolder
    {

        RTexture[] mTextures;
        int MaxIndex;


        public RTextureHolder(){
            MaxIndex = 0;

            mTextures = new RTexture[255];
        }
        public void LoadHolder(string HolderFilename)
        {
            StreamReader sr = new StreamReader(HolderFilename);
            String	Line;
            int currentIndex;

            Line = sr.ReadLine();
            Line = sr.ReadLine();
            MaxIndex = System.Convert.ToInt32(Line);


            for (int i = 0; i < MaxIndex; i++){

                Line = sr.ReadLine();
                currentIndex = System.Convert.ToInt32(Line); 

                Line = sr.ReadLine();
                mTextures[currentIndex] = new RTexture(Line);

			
            }
        }

        public void AddTextureFile(string FileName)
        {
            mTextures[MaxIndex] = new RTexture(FileName);
            MaxIndex++;
        }

        public void SaveHolder(string HolderFilename)
        {

   			StreamWriter sw = new StreamWriter(HolderFilename);

            sw.WriteLine("MaxIndex:");
            sw.WriteLine(MaxIndex);

            for (int i = 0; i < MaxIndex; i++)
            {
                sw.WriteLine(i);
                mTextures[i].Save(sw);
            }
            sw.Close();

        }
        public Color GetColor(int x, int y, uint ColorValue)
        {

            
            return mTextures[ColorValue].GetPixel(x, y);
        }
        void SetTexture(int Index, string BitmapFilename) 
        {
            mTextures[Index] = new RTexture(BitmapFilename);
        }
    }
}
